using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.ComponentModel;

namespace GLCDView
{
	public class NumericTextBox : TextBox
	{
		private bool allowDecimal = false;
		
		
		[DefaultValue(false)]
		public bool AllowDecimal
		{
			get { return this.allowDecimal; }
			set { this.allowDecimal = value; }
		}

		protected override void OnKeyPress(KeyPressEventArgs e)
		{
			string keys;
			if (this.allowDecimal)
				keys = "\b0123456789,";
			else
				keys = "\b0123456789";

			if (e.KeyChar != (char)22) // Ctrl+V
			{
				if (-1 == keys.IndexOf(e.KeyChar))
					e.Handled = true;
			}
			base.OnKeyPress(e);
		}
		
	}
}
