using System;
using System.Xml;
using System.Collections;
using System.Text;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization;
using System.IO;

namespace RCRequisites
{
	public class ObjectSerialize
	{
		public static string ObjectToString(object o)
		{
			byte[] bytes = SerializeObjectToByteArray(o);
			if(null != bytes)
				return ByteArrayToString(bytes);
			return string.Empty;
		}

		public static object StringToObject(string s)
		{
			return DeserializeObjectFromByteArray(StringToByteArray(s));
		}
		
		public static string ByteArrayToString(byte[] bytes)
		{
			StringBuilder sb = new StringBuilder();
			for(int i=0; i < (int)bytes.Length; i++)
				sb.Append(string.Format("{0,2:x2}|", bytes[i]));
			return sb.ToString();
		}
		
		public static byte[] StringToByteArray(string s)
		{
			ArrayList bytes = new ArrayList();
			string[] parts = s.Split('|');
			for(int i=0; i < parts.Length-1; i++)
				bytes.Add(Convert.ToByte(parts[i], 16));
			return bytes.ToArray(typeof(byte)) as byte[];
		}

		public static byte[] SerializeObjectToByteArray(object obj)
		{
			MemoryStream stream = new MemoryStream();
			BinaryFormatter formatter = new BinaryFormatter();
			formatter.AssemblyFormat = FormatterAssemblyStyle.Simple;
			byte[] bytes = null;

			if (obj != null && stream != null && formatter != null && obj.GetType().IsSerializable == true)
			{
				try
				{
					formatter.Serialize(stream, obj);					
					stream.Flush();
					stream.Position = 0;
					bytes = stream.ToArray();
				}
				catch (Exception error)
				{
					Exception exception = new Exception("Object not serializable!", error);
					throw exception;
				}
				finally
				{
					stream.Close();
				}					
			}	
			return bytes;
		}

		public static object DeserializeObjectFromByteArray(byte[] bytes)
		{
			MemoryStream stream = new MemoryStream();
			BinaryFormatter formatter = new BinaryFormatter();
			formatter.AssemblyFormat = FormatterAssemblyStyle.Simple;
					
			object obj = null;
			if (bytes != null && stream != null && formatter != null)
			{						
				try
				{
					stream.Write(bytes, 0, bytes.GetLength(0));
					stream.Flush();
					stream.Position = 0;		
					obj = formatter.Deserialize(stream);
				}
				catch (Exception error)
				{
					Exception exception = new Exception("Object not deserializable!", error);
					throw exception;
				}
				finally
				{
					stream.Close();
				}			
			}
			return obj;
		}
	}
}
